library(survival)
library(MASS)
library(asaur)
#library(KMsurv)

############## Exercise: construction and interpretation of a Cox model for the pharmocoSmoking dataset
data("pharmacoSmoking")
names(pharmacoSmoking)
head(pharmacoSmoking)


summary(coxph(Surv(ttr,relapse) ~ . - id, data = pharmacoSmoking))

summary(coxph(Surv(ttr,relapse) ~ grp + age + gender + race+ employment+ yearsSmoking+levelSmoking+priorAttempts+longestNoSmoke , data = pharmacoSmoking))
summary(coxph(Surv(ttr,relapse) ~ grp + age + gender + race+ employment+ yearsSmoking+priorAttempts+longestNoSmoke , data = pharmacoSmoking))
summary(coxph(Surv(ttr,relapse) ~ grp + age + gender + employment+ yearsSmoking+priorAttempts+longestNoSmoke , data = pharmacoSmoking))
summary(coxph(Surv(ttr,relapse) ~ grp + age + gender + employment+ yearsSmoking+longestNoSmoke , data = pharmacoSmoking))
summary(coxph(Surv(ttr,relapse) ~ grp + age + employment+ yearsSmoking+longestNoSmoke , data = pharmacoSmoking))
summary(coxph(Surv(ttr,relapse) ~ grp + age + employment+ longestNoSmoke , data = pharmacoSmoking))

summary(coxph(Surv(ttr,relapse) ~ grp + age + gender + race+ employment+priorAttempts+longestNoSmoke , data = pharmacoSmoking))
summary(coxph(Surv(ttr,relapse) ~ grp + age + race+ employment+priorAttempts+longestNoSmoke , data = pharmacoSmoking))
summary(coxph(Surv(ttr,relapse) ~ grp + age + race+ employment+longestNoSmoke , data = pharmacoSmoking))


summary(coxph(Surv(ttr,relapse) ~ grp + age + race + employment , data = pharmacoSmoking))
summary(coxph(Surv(ttr,relapse) ~ grp + age  + employment , data = pharmacoSmoking))




summary(coxph(Surv(ttr,relapse) ~ grp + age +  employment , data = pharmacoSmoking))
summary(coxph(Surv(ttr,relapse) ~ grp + age +  employment , data = pharmacoSmoking))

1-pchisq(3.17 ,3)


############## Exercise: left-truncated and right-censored data
library(KMsurv)
data("channing")
head(channing)

channing[channing$ageentry==channing$age,]
channing$age_transform = channing$age
channing$age_transform[channing$ageentry==channing$age] = channing$age[channing$ageentry==channing$age]+0.5

fit_channing = survfit(Surv(ageentry,age_transform,death)~1, data = channing)
summary(fit_channing)
plot(fit_channing)

fit_channing_by_gender = survfit(Surv(ageentry,age_transform,death) ~ gender, data = channing)
summary(fit_channing_by_gender)
plot(fit_channing_by_gender)




#Fit one curve for the women
SF.women <- survfit( Surv( ageentry,age,death ), 
                     data=channing[channing$time>0 &  channing$gender==2,])
#Plot the surival function
plot(SF.women$time/12,SF.women$surv,type="S")


#Fit one curve for the men
SF.men <- survfit( Surv( ageentry,age,death ), data=channing[channing$time>0 &  channing$gender==1,])
#Plot the surival function
plot(SF.men$time/12,SF.men$surv,type="S")

#The strange behaviour of the survival function estimate for the men depends on the number at risk
SF.men$n.risk

#Conditional probability of survival
SF.men.68 <- survfit( Surv( ageentry,age,death ), 
                      data=channing[channing$time>0 &  channing$gender==1 & channing$ageentry/12>68,])

SF.women.68 <- survfit( Surv( ageentry,age,death ), 
                        data=channing[channing$time>0 &  channing$gender==2 & channing$ageentry/12>68,])
SF.men.80 <- survfit( Surv( ageentry,age,death ), 
                      data=channing[channing$time>0 &  channing$gender==1 & channing$ageentry/12>80,])

SF.women.80 <- survfit( Surv( ageentry,age,death ), 
                        data=channing[channing$time>0 &  channing$gender==2 & channing$ageentry/12>80,])
plot( SF.men.68$time/12 ,SF.men.68$surv,xlim=c(70,100),ylim=c(0,1),type='s',col="red",xlab="Age",ylab="Estimated conditional survival function")
points(SF.women.68$time/12 ,SF.women.68$surv,type='s',col="pink")
points(SF.men.80$time/12 ,SF.men.80$surv,type='s',col="blue")
points(SF.women.80$time/12 ,SF.women.80$surv,type='s',col="lightblue")

